#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <grp.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE); \
        }\
    } while (0)

void printGroup(struct group* gr) {

    printf("Group name: %s\n", gr->gr_name);
    printf("Group id: %d\n", gr->gr_gid);
    printf("Group members: \n");
    for (char** s = gr->gr_mem; *s != NULL; s++) {
        printf("\t%s\n", *s);
    }
    printf("*******************************\n");
}

int main(int argc, char** argv) {

    checkError(argc == 1, "args");

    setgrent();

    struct group* grp = NULL;
    while ((grp = getgrent()) != NULL) {

        printGroup(grp);
    }

    endgrent();

    exit(EXIT_SUCCESS);
}