#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <pwd.h>

#include <stdio.h>
#include <stdlib.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE); \
        }\
    } while (0)

int main(int argc, char** argv) {

    checkError(argc == 1, "args");

    setpwent();

    struct passwd* ent = NULL;
    while ((ent = getpwent()) != NULL) {

        printf("Username: %s\n", ent->pw_name);
        printf("User ID: %d\n", (int)ent->pw_uid);
        printf("Group ID: %d\n", (int)ent->pw_gid);
        printf("User info: %s\n", ent->pw_gecos);
        printf("Homedir: %s\n", ent->pw_dir);
        printf("Shell: %s\n", ent->pw_shell);
        printf("***************************************\n");
    }

    endpwent();

    exit(EXIT_SUCCESS);
}