#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#include <grp.h>
#include <string.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE); \
        }\
    } while (0)

void printGroup(struct group* gr) {

    printf("Group name: %s\n", gr->gr_name);
    printf("Group id: %d\n", gr->gr_gid);
    printf("Group members: \n");
    for (char** s = gr->gr_mem; *s != NULL; s++) {
        printf("\t%s\n", *s);
    }
    printf("*******************************\n");
}

int main(int argc, char** argv) {

    checkError(argc == 3, "args");

    if (strcmp(argv[1], "-g") == 0) {

        int gr = atoi(argv[2]);
        struct group * grp = getgrgid((gid_t)gr);
        if (grp != NULL)
            printGroup(grp);
        else
            printf("Ne postoji grupa\n");
    }
    else if (strcmp(argv[1], "-n") == 0) {

        struct group* grp = getgrnam(argv[2]);
        if (grp != NULL)
            printGroup(grp);
        else
            printf("Ne postoji grupa\n");
    }
    else {
        checkError(0, "opt -g|n");
    }

    exit(EXIT_SUCCESS);
}