#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <pwd.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE); \
        }\
    } while (0)

void printUser(struct passwd* ent) {

    if (ent == NULL) {
        printf("Ne postoji korisnik\n");
        return;
    }

    printf("Username: %s\n", ent->pw_name);
    printf("User ID: %d\n", (int)ent->pw_uid);
    printf("Group ID: %d\n", (int)ent->pw_gid);
    printf("User info: %s\n", ent->pw_gecos);
    printf("Homedir: %s\n", ent->pw_dir);
    printf("Shell: %s\n", ent->pw_shell);
    printf("***************************************\n");
}

int main(int argc, char** argv) {
    // ./a.out -n vladimir
    // ./a.out -u 1000
    checkError(argc == 3, "args");

    if (strcmp(argv[1], "-u") == 0) {

        int id = atoi(argv[2]);
        struct passwd* pwd = getpwuid((uid_t)id);

        printUser(pwd);
    }
    else if (strcmp(argv[1], "-n") == 0) {
        struct passwd* pwd = getpwnam(argv[2]);

        printUser(pwd);
    }
    else {
        checkError(0, "opt -u|n");
    }

    exit(EXIT_SUCCESS);
}