#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE); \
        }\
    } while (0)

int main(int argc, char** argv) {

    checkError(argc == 2, "args");

    struct stat fInfo;
    checkError(stat(argv[1], &fInfo) != -1, "stat failed");

    struct passwd* pwd = getpwuid(fInfo.st_uid);
    checkError(pwd != NULL, "getpwuid failed");

    printf("Owner: %s\n", pwd->pw_name);

    exit(EXIT_SUCCESS);
}